from dataclasses import dataclass
from Global import *
CARD_BORDER_WIDTH = 5
CARD_FILL_COLOR = 'white'
CARD_FONT_SIZE = 24
CARD_MIN_WIDTH = 100
CARD_MIN_HEIGHT = 50

@dataclass
class Card:
  x:int = 20
  y:int = 20
  width:int = CARD_MIN_WIDTH
  height:int = CARD_MIN_HEIGHT
  text:str = 'Hi!'
  mode:int = 0 #0:normal, 1:move, 2:resize, 3:edit
  rectId:int = 0
  textId:int = 0

  def clearId(self):
    self.rectId = 0
    self.textId = 0

  def setMode(self, x:int, y: int):
    if (x >= self.x and x <= self.x + self.width and
        y >= self.y and y < self.y + self.height // 2):
      self.mode = 1
    elif (x >= self.x + self.width // 2 and
          x < self.x + self.width and
          y >= self.y + self.height // 2 and
          y <= self.y + self.height):
      self.mode = 2
    elif (x >= self.x and
          x <= self.x + self.width // 2 and
          y >= self.y + self.height // 2 and
          y <= self.y + self.height):
      self.mode = 3
    else:
      self.mode = 0