import tkinter
from Point import Point

class MouseInfo:
  def __init__(self, root:tkinter.Tk):
    root.title(self.__class__.__name__)
    root.geometry('500x200')
    root.bind('<Configure>', self.configure)
    self.canvas = tkinter.Canvas(root, bg='white')
    self.canvas.pack(expand=True, fill=tkinter.BOTH)
    self.canvas.bind('<ButtonPress-1>', self.b1Press)
    self.canvas.bind('<B1-Motion>', self.b1Motion)
    self.canvas.bind('<ButtonRelease-1>', self.b1Release)
    self.afterId = None
    self.b1PressP = Point()
    self.b1MotionP = Point()
    self.b1ReleaseP = Point()
    self.mouseInfoId = 0

  def configure(self, event=None):
    self.update()

  def update(self):
    if self.afterId != None:
      root.after_cancel(self.afterId)
    self.canvas.delete(self.mouseInfoId)
    self.mouseInfoId = self.canvas.create_text(
      10, 10, anchor='w', text=str(self.b1PressP) + '->' +
      str(self.b1MotionP) + '->' + str(self.b1ReleaseP))
    self.afterId = root.after(100, self.update)

  def b1Press(self, event=None):
    self.b1PressP.setValue(event.x, event.y)

  def b1Motion(self, event=None):
    self.b1MotionP.setValue(event.x, event.y)

  def b1Release(self, event=None):
    self.b1ReleaseP.setValue(event.x, event.y)

root = tkinter.Tk()
MouseInfo(root)
root.mainloop()